unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Image1Paint(Sender: TObject);
  private
   FHour : Word;
   FMin  : Word;
   FSec  : Word;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  math;

const
  Deg2Rad = pi/180;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Picture.Bitmap.SetSize(Image1.Width, Image1.Height);

  // make image and bitmap transparency,using clAque for transparentcolor
  Image1.Picture.Bitmap.Canvas.Brush.Color:= clAqua;
  Image1.Picture.Bitmap.Canvas.FillRect(0, 0, Image1.Width, Image1.Height);
  Image1.Picture.Bitmap.TransparentMode:= tmFixed;
  Image1.Picture.Bitmap.TransparentColor := clAqua;
  Image1.Picture.Bitmap.Transparent:=true;
  Image1.Transparent:=true;

  Timer1Timer(Nil);
end;


procedure TForm1.Memo1Change(Sender: TObject);
begin
  // Is this the correct way to autoscroll a memo ?
  Memo1.CaretPos := point(0, Memo1.Lines.Count-1);
end;


procedure TForm1.Timer1Timer(Sender: TObject);
const
  itercount : longint = 0;
var
  junk    : word;
  nowtime : TDateTime;
begin
  nowtime := Now;
  inc(itercount);
  Memo1.Append(FormatDateTime('hh":"mm":"ss"."zzz  ', nowtime) + '(' + IntToStr(itercount) + ')');
  DecodeTime(nowtime,FHour,FMin,FSec,Junk);

  Image1.Invalidate;
end;


procedure TForm1.Image1Paint(Sender: TObject);
//const
//  ro=20;    // Minutenzeiger
var
  centerX : integer = 45;
  centerY : integer = 47;
  ro      : integer = 20;
  x,y,x1,y1,x2,y2 : integer;
  h,degH, degMin, degSec, sinus, cosinus : single;
begin
  memo1.Append('> paint');

  // lets increase the size of the clock
  centerx := Image1.Width  div 2;  // override defaults
  centery := Image1.Height div 2;  // override defaults
  ro := centerx div 2 - 5;         // override defaults

  // hours
  h := Fhour;
  if h >=12 then h := h - 12;
  h := h + FMin/60;
  degH :=  h* 30 - 90;   // Uhr (Nord) fängt 90° vor Lazarus (Ost) an
  math.sincos(degH*Deg2Rad, sinus, cosinus);
  x := round(cosinus * ro * 0.75) + centerX;
  y := round(sinus   * ro * 0.75) + CenterY;
  // minutes
  degMin :=  Fmin*6 -90;
  math.sincos(degMin*Deg2Rad, sinus, cosinus);
  x1 := round(cosinus * ro) + centerX;
  y1 := round(sinus   * ro) + centerY;
  // seconds
  degSec := FSec*6 -90;
  math.sincos(degSec*Deg2Rad, sinus, cosinus);
  x2 := round(cosinus * ro * 1.15) + centerX;
  y2 := round(sinus   * ro * 1.15) + centerY;
  with Image1.Canvas do
  begin
    pen.width   := 5;
    pen.Color   := clBlack;
    pen.EndCap  := pecRound;
    line(centerX, centerY, x , y );  // hours
    line(centerX, centerY, x1, y1);  // minutes
    pen.width   := 1;
    brush.Color := clLime;
    EllipseC(x ,y ,3,3);    // radium, luminous lime-green, very 60th
    EllipseC(x1,y1,3,3);
    pen.Color   := clRed;
    line(centerX, centerY, x2, y2);  // seconds
    pen.Color   := clBlack;
    Brush.color := clSilver;
    EllipseC(centerX, centerY,3,3);
  end;
  memo1.Append('< paint');
end;


end.



(*
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes,  Controls, Dialogs, Forms,Graphics, ExtCtrls,
  SysUtils, Math;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    Timer1: TTimer;

    procedure FormCreate(Sender: TObject);
    procedure Image1Paint(Sender: TObject);
    Procedure Timer1Timer (Sender : TObject);


  private
   AHour : Word;
   AMin : Word;
   ASec : Word;
  public
  end;
 const Deg2Rad = pi/180;
 var
  Form1: TForm1;

implementation

{$R *.lfm}

 procedure TForm1.FormCreate(Sender: TObject);
  begin
   Timer1Timer(Nil);
 end;

 Procedure TForm1.Timer1Timer (Sender : TObject);
  var junk : word;
  begin
   DecodeTime(Now,AHour,AMin,ASec,Junk);
   Image1.Invalidate;
 end;

 // analog clock, image 90 x 90
 procedure TForm1.Image1Paint(Sender: TObject);
  const ro=20;    // Minutenzeiger
        centerX=45;
        centerY=47;
  var x,y,x1,y1,x2,y2 : integer;
      h,degH, degMin, degSec, sinus, cosinus : single;
  begin
  // hours
    h := Ahour;
    if h >=12 then h := h - 12;
       h := h + AMin/60;
       degH :=  h* 30 - 90;   // Uhr (Nord) fängt 90° vor Lazarus (Ost) an
       math.sincos(degH*Deg2Rad, sinus, cosinus);
       x := round (cosinus*ro*0.75)+centerX;
       y := round (sinus *ro*0.75) +CenterY;
       // minutes
       degMin :=  Amin*6 -90;
       math.sincos(degMin*Deg2Rad, sinus, cosinus);
       x1 := round (cosinus*ro)+centerX;
       y1 := round (sinus*ro)+centerY;
       // seconds
       degSec := ASec*6 -90;
       math.sincos(degSec*Deg2Rad, sinus, cosinus);
       x2 := round (cosinus*ro*1.15)+centerX;
       y2 := round (sinus*ro*1.15)+centerY;
       with Image1.Canvas do begin
          pen.width := 5;
          pen.Color := clBlack;
          pen.EndCap :=   pecRound;
          line(centerX, centerY,x,y);  // hours
          line(centerX, centerY,x1,y1);   // minutes
          pen.width := 1;
          brush.Color := clLime;
          EllipseC(x,y,3,3);    // radium, luminous lime-green, very 60th
          EllipseC(x1,y1,3,3);
          pen.Color := clRed;
          line(centerX, centerY,x2,y2);    // seconds
          pen.Color := clBlack;
          Brush.color := clSilver;
          EllipseC (centerX, centerY,3,3);
       end;
    end;
end.
*)

